<script setup lang="ts">
import { reactive } from "vue";
import { useUsers } from "../stores/useUsers";
import AddUserButton from "./AddUserButton.vue";
import UserAddModal from "./UserAddModal.vue";
import type { TUser } from "../types/user.type";

const modalAddUser = reactive<{ open: boolean }>({ open: false });

const store = useUsers();

function handleClickAddUser() {
  modalAddUser.open = true;
}

function handleSaveAddUser(user: TUser) {
  store.addUser(user);
  modalAddUser.open = false;
}

function handleCancelAddUser() {
  modalAddUser.open = false;
}
</script>

<template>
  <section class="mb-4 flex h-16 items-center justify-between lg:mb-8 lg:h-20">
    <div
      class="flex flex-1 flex-col items-start justify-center gap-2 @container"
    >
      <h1 class="text-3xl font-semibold">Users</h1>
      <p class="hidden font-light @xl:block">
        A list of all the users in your account including their name, title,
        email and role.
      </p>
    </div>
    <AddUserButton @click="handleClickAddUser" />
  </section>

  <UserAddModal
    v-if="modalAddUser.open"
    :open="modalAddUser.open"
    @save="handleSaveAddUser"
    @close="handleCancelAddUser"
  />
</template>
